import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikAvatarProps.dart';
import 'package:flutter/material.dart';

class UikAvatar extends UikWidget {
  WidgetType _widgetType;
  UikAvatarProps _uikAvatarProps;
  UikAvatar(this._widgetType, this._uikAvatarProps)
      : super(_widgetType, _uikAvatarProps);

  @override
  _UikAvatarState createState() => _UikAvatarState(_uikAvatarProps);
}

class _UikAvatarState extends State<UikAvatar> {
  UikAvatarProps _uikAvatarProps;
  _UikAvatarState(this._uikAvatarProps);
  BoxShape get _avatarShape {
    if (_uikAvatarProps.shape == BoxShape.circle) {
      return BoxShape.circle;
    } else if (_uikAvatarProps.shape == BoxShape.rectangle) {
      return BoxShape.rectangle;
    } else {
      return BoxShape.circle;
    }
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.all(_uikAvatarProps.padding),
      child: Column(children: [
        AnimatedContainer(
          width: _uikAvatarProps.width,
          height: _uikAvatarProps.height,
          duration: kThemeChangeDuration,
          decoration: BoxDecoration(
            color: _uikAvatarProps.backgroundColor,
            image: _uikAvatarProps.backgroundImage != null
                ? DecorationImage(
                    // colorFilter: ColorFilter.mode(Colors.white, BlendMode.clear),
                    fit: BoxFit.fill,
                    image: NetworkImage(_uikAvatarProps.backgroundImage!),
                  )
                : null,
            shape: _avatarShape,
            borderRadius: (_uikAvatarProps.shape == BoxShape.rectangle)
                ? BorderRadius.circular(_uikAvatarProps.borderRadius)
                : null,
          ),
          // child: child == null && textStyle != null
          //     ? null
          //     : Center(
          //         child: MediaQuery(
          //           data: MediaQuery.of(context).copyWith(textScaleFactor: 1),
          //           child: IconTheme(
          //             data: theme.iconTheme.copyWith(color: textStyle?.color),
          //             child: DefaultTextStyle(
          //               style: textStyle!,
          //               child: child!,
          //             ),
          //           ),
          //         ),
          //       ),
        ),
      ]),
    );
  }
}
