import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';
import '../props/UikBagItemProps.dart';

class UikBagItem extends UikWidget {
  WidgetType _widgetType;
  UikBagItemProps _uikBagItemProps;
  UikBagItem(this._widgetType, this._uikBagItemProps)
      : super(_widgetType, _uikBagItemProps);

  @override
  _UikBagItemState createState() => _UikBagItemState(_uikBagItemProps);
}

class _UikBagItemState extends State<UikBagItem> {
  UikBagItemProps _uikBagItemProps;
  _UikBagItemState(this._uikBagItemProps);

  @override
  Widget build(BuildContext context) {
      return Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Container(
          width: 400,
          height: 150,
          // decoration: BoxDecoration(
          //             border: Border.all(color: Colors.blueAccent)     
          //            ),
          child: Row(
            children: [
              //............................................Image...................................................//
              Flexible(
                child: Container(
                  width: 94,
                  height: 115,
                  margin: EdgeInsets.only(left: 16),
                  decoration: BoxDecoration(
                    borderRadius: BorderRadius.circular(8),
                    image: DecorationImage(
                      image: NetworkImage(
                        _uikBagItemProps.imageUrl
                      ),
                       fit: BoxFit.cover,
                    ),
                    // shape: BoxShape.circle,
                  ),
                ),
              ),
              SizedBox(
                width: 16,
              ),
              //...............................................ImgPrice.........................................//
              Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  SizedBox(
                    height: 15,
                  ),
                  Container(
                    width: 201,
                    height: 24,
                    child: Text(
                      _uikBagItemProps.productPrice,
                      style: TextStyle(
                        fontFamily: GoogleFonts.poppins().fontFamily,
                        fontWeight: FontWeight.w500,
                        fontSize: 16,
                        color: Color(0xFF212121),
                      ),
                    ),
                  ),
                  //........................................................ImgDescription..............................//
                  Container(
                    width: 201,
                    height: 32,
                    // color: Colors.black,
                    child: Text(
                      _uikBagItemProps.productDescription,
                      style: TextStyle(
                        fontWeight: FontWeight.w400,
                        fontFamily: GoogleFonts.poppins().fontFamily,
                        fontSize: 12,
                        color: Color(0xFF9E9E9E),
                      ),
                    ),
                  ),
                  SizedBox(
                    height: 20,
                  ),

                  if(_uikBagItemProps.stepper != null) ...[
                    _uikBagItemProps.stepper!
                  ]
                  // Container(
                  //   child: MyStepper(),
                  //   width: 98,
                  //   height: 36,
                  //   margin: EdgeInsets.only(left: 0),
                  //   color: Colors.pink,
                  // ),

                  //.....................................................Stepper..............................................//

                  // Container(
                  //   // child: MyStepper(),
                  //   // alignment: Alignment.centerLeft,
                  //   width: 201,
                  //   height: 36,
                  //   color: Colors.blue,
                  //   // height: 12,
                  //   // color: Colors.pink,
                  //   child: MyStepper(),
                  // ),
                 // MyStepper(
                      // itemPrice: imgPrice,
                      // fun: ScreenFunction,
                     // ),
                ],
              ),
              //................................................CrossShape..............................................//
              Column(
                mainAxisAlignment: MainAxisAlignment.start,
                children: [
                  // SizedBox(
                  //   height: 18,
                  // ),
                  Container(
                     margin: EdgeInsets.only(left: 16,top: 16),
                    //  decoration: BoxDecoration(
                    //   border: Border.all(color: Colors.blueAccent)     
                    //  ),
                    // width: 200,
                    // height: 200,
                    child: (_uikBagItemProps.deleteIcon != null)
                    ? _uikBagItemProps.deleteIcon : null,
                    // decoration: BoxDecoration(
                    //   image: DecorationImage(
                    //     image:NetworkImage(
                    //       "https://images.pexels.com/photos/213780/pexels-photo-213780.jpeg?auto=compress&cs=tinysrgb&dpr=1&w=500,https://images.pexels.com/photos/213780/pexels-photo-213780.jpeg?auto=compress&cs=tinysrgb&dpr=1&w=500,https://images.pexels.com/photos/213780/pexels-photo-213780.jpeg?auto=compress&cs=tinysrgb&dpr=1&w=500"
                    //       ),
                    //     fit: BoxFit.fill,
                    //   ),
                    //   shape: BoxShape.circle,
                    // ),
                  ),
                ],
              ),
            ],
          ),
    ),
        ],
      );
  }
}
