import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/utils/UikActionListner.dart';
import 'package:flutter/material.dart';
import 'package:ui_sdk/utils/pubsub/localpubsub.dart';

class UikButton extends UikWidget {
  WidgetType _widgetType;
  UikButtonProps _uikButtonProps;
  UikButton(
    this._widgetType,
    this._uikButtonProps,
  ) : super(_widgetType, _uikButtonProps);

  @override
  _UikButtonState createState() => _UikButtonState(_uikButtonProps);
}

class _UikButtonState extends State<UikButton> {
  UikButtonProps _uikButtonProps;
  _UikButtonState(this._uikButtonProps);

  @override
  Widget build(BuildContext context) {
    return MouseRegion(
      cursor: SystemMouseCursors.click,
      child: InkWell(
        //onTap: _uikButtonProps.onClick,

        child: Column(
          crossAxisAlignment: (_uikButtonProps.isCenter != true)
              ? CrossAxisAlignment.start
              : CrossAxisAlignment.center,
          children: [
            if (_uikButtonProps.type == "primary") ...[
              InkWell(
                onTap: () async {
                  PubSub pubsub = PubSub();
                  await executeUikWidgetAction(_uikButtonProps.action);
                  // ScaffoldMessenger.of(context).showSnackBar(const SnackBar(
                  //   content: Text('Tap'),
                  // ));
                },
                child: Container(
                  width: _uikButtonProps.widthSize,
                  // width: MediaQuery.of(context).size.width -
                  //     _uikButtonProps.widthSize,
                  height: _uikButtonProps.heightSize,
                  margin: EdgeInsets.fromLTRB(
                      _uikButtonProps.leftMargin,
                      _uikButtonProps.topMargin,
                      _uikButtonProps.rightMargin,
                      _uikButtonProps.bottomMargin),
                  decoration: BoxDecoration(
                    color: _uikButtonProps.backgroundColor,
                    borderRadius:
                        BorderRadius.circular(_uikButtonProps.borderRadius!),
                    border: Border.all(
                        color: _uikButtonProps.borderColor, width: 1.0),
                  ),
                  child: (_uikButtonProps.isStuck == true)
                      ? Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            Container(
                              child: _buildLeadingIcon(
                                  _uikButtonProps.leftElement),
                            ),
                            Center(
                              child: _uikButtonProps.text,
                              // Text(
                              // //   style: GoogleFonts.poppins(
                              // //     fontWeight: _uikButtonProps.textWeight,
                              // //     color: _uikButtonProps.textColor,
                              // //     fontSize: _uikButtonProps.textSize,
                              // //   ),
                              // ),
                            ),
                            Container(
                              child: _buildTrailingIcon(
                                  _uikButtonProps.rightElement),
                            ),
                          ],
                        )
                      : Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            Container(
                              margin: EdgeInsets.only(left: 20),
                              child: _buildLeadingIcon(
                                  _uikButtonProps.leftElement),
                            ),
                            Spacer(),
                            Expanded(
                              child: Center(
                                child: _uikButtonProps.text,
                                // Text(

                                //   style: GoogleFonts.poppins(
                                //     fontWeight: _uikButtonProps.textWeight,
                                //     color: _uikButtonProps.textColor,
                                //   ),
                                // ),
                              ),
                            ),
                            Spacer(),
                            Container(
                              margin: EdgeInsets.only(right: 22),
                              child: _buildTrailingIcon(
                                  _uikButtonProps.rightElement),
                            ),
                          ],
                        ),
                ),
              ),
            ] else if (_uikButtonProps.type == "secondary") ...[
              Container(
                // width: _uikButtonProps.widthSize,
                width: MediaQuery.of(context).size.width -
                    _uikButtonProps.widthSize,
                height: _uikButtonProps.heightSize,
                decoration: BoxDecoration(
                  color: _uikButtonProps.backgroundColor,
                  borderRadius: BorderRadius.circular(7),
                  border: Border.all(
                      color: _uikButtonProps.borderColor, width: 1.0),
                ),
                child: (_uikButtonProps.isStuck == true)
                    ? Row(
                        mainAxisAlignment: MainAxisAlignment.center,
                        children: [
                          Container(
                            child:
                                _buildLeadingIcon(_uikButtonProps.leftElement),
                          ),
                          Center(
                            child: _uikButtonProps.text,
                            // Text(

                            //   style: GoogleFonts.poppins(
                            //     fontWeight: _uikButtonProps.textWeight,
                            //     color: _uikButtonProps.textColor,
                            //   ),
                            // ),
                          ),
                          Container(
                            child: _buildTrailingIcon(
                                _uikButtonProps.rightElement),
                          ),
                        ],
                      )
                    : Row(
                        mainAxisAlignment: MainAxisAlignment.center,
                        children: [
                          Container(
                            margin: EdgeInsets.only(left: 20),
                            child:
                                _buildLeadingIcon(_uikButtonProps.leftElement),
                          ),
                          Spacer(),
                          Expanded(
                            child: Center(
                              child: _uikButtonProps.text,
                              // Text(

                              //   style: GoogleFonts.poppins(
                              //     fontWeight: _uikButtonProps.textWeight,
                              //     color: _uikButtonProps.textColor,
                              //   ),
                              // ),
                            ),
                          ),
                          Spacer(),
                          Container(
                            margin: EdgeInsets.only(right: 2),
                            child: _buildTrailingIcon(
                                _uikButtonProps.rightElement),
                          ),
                        ],
                      ),
              ),
            ] else if (_uikButtonProps.type == "outline") ...[
              Container(
                // width: _uikButtonProps.widthSize,
                width: MediaQuery.of(context).size.width -
                    _uikButtonProps.widthSize,
                height: _uikButtonProps.heightSize,
                decoration: BoxDecoration(
                  color: _uikButtonProps.backgroundColor,
                  borderRadius: BorderRadius.circular(7),
                  border: Border.all(
                      color: _uikButtonProps.borderColor, width: 1.0),
                ),
                child: (_uikButtonProps.isStuck == true)
                    ? Row(
                        mainAxisAlignment: MainAxisAlignment.center,
                        children: [
                          Container(
                            child:
                                _buildLeadingIcon(_uikButtonProps.leftElement),
                          ),
                          Center(
                            child: _uikButtonProps.text,
                            // Text(

                            //   style: GoogleFonts.poppins(
                            //     fontWeight: _uikButtonProps.textWeight,
                            //     color: _uikButtonProps.textColor,
                            //   ),
                            // ),
                          ),
                          Container(
                            child: _buildTrailingIcon(
                                _uikButtonProps.rightElement),
                          ),
                        ],
                      )
                    : Row(
                        mainAxisAlignment: MainAxisAlignment.center,
                        children: [
                          Container(
                            margin: EdgeInsets.only(left: 20),
                            child:
                                _buildLeadingIcon(_uikButtonProps.leftElement),
                          ),
                          Spacer(),
                          Expanded(
                            child: Center(
                              child: _uikButtonProps.text,
                              // Text(

                              //   style: GoogleFonts.poppins(
                              //     fontWeight: _uikButtonProps.textWeight,
                              //     color: _uikButtonProps.textColor,
                              //   ),
                              // ),
                            ),
                          ),
                          Spacer(),
                          Container(
                            margin: EdgeInsets.only(right: 22),
                            child: _buildTrailingIcon(
                                _uikButtonProps.rightElement),
                          ),
                        ],
                      ),
              ),
            ] else ...[
              //ghost
              Container(
                // width: _uikButtonProps.widthSize,
                width: MediaQuery.of(context).size.width -
                    _uikButtonProps.widthSize,
                height: _uikButtonProps.heightSize,
                decoration: BoxDecoration(
                  color: _uikButtonProps.backgroundColor,
                  borderRadius: BorderRadius.circular(7),
                  border: Border.all(
                      color: _uikButtonProps.borderColor, width: 1.0),
                ),
                child: (_uikButtonProps.isStuck == true)
                    ? Row(
                        mainAxisAlignment: MainAxisAlignment.center,
                        children: [
                          Container(
                            child:
                                _buildLeadingIcon(_uikButtonProps.leftElement),
                          ),
                          Center(
                            child: _uikButtonProps.text,
                            // Text(

                            //   style: GoogleFonts.poppins(
                            //     fontWeight: _uikButtonProps.textWeight,
                            //     color: _uikButtonProps.textColor,
                            //   ),
                            // ),
                          ),
                          Container(
                            child: _buildTrailingIcon(
                                _uikButtonProps.rightElement),
                          )
                        ],
                      )
                    : Row(
                        mainAxisAlignment: MainAxisAlignment.center,
                        children: [
                          Container(
                            margin: EdgeInsets.only(left: 20),
                            child:
                                _buildLeadingIcon(_uikButtonProps.leftElement),
                          ),
                          Spacer(),
                          Expanded(
                            child: Center(
                              child: _uikButtonProps.text,
                            ),
                          ),
                          Spacer(),
                          Container(
                            margin: EdgeInsets.only(right: 22),
                            child: _buildTrailingIcon(
                                _uikButtonProps.rightElement),
                          ),
                        ],
                      ),
              ),
            ],
          ],
        ),
      ),
    );
  }
}

Widget _buildTrailingIcon(final rightElement) {
  if (rightElement != null) {
    return Row(
      children: <Widget>[
        SizedBox(width: 5),
        rightElement,
      ],
    );
  }
  return Container();
}

Widget _buildLeadingIcon(final leftElement) {
  if (leftElement != null) {
    return Row(
      children: <Widget>[
        leftElement,
        SizedBox(width: 5),
      ],
    );
  }
  return Container();
}
