import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import "package:flutter/material.dart";

import '../props/UikChipsProps.dart';
import 'UikIcon.dart';
import 'UikWidget.dart';

class UikChips extends UikWidget {
  WidgetType _widgetType;
  UikChipsProps _uikChipsProps;
  UikChips(this._widgetType, this._uikChipsProps)
      : super(_widgetType, _uikChipsProps);

  @override
  _UikChipsState createState() => _UikChipsState(_uikChipsProps);
}

class _UikChipsState extends State<UikChips> {
  UikChipsProps _uikChipsProps;
  _UikChipsState(this._uikChipsProps);

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        Container(
          //alignment: Alignment.topCenter,
          //margin: EdgeInsets.only(top: 20),
          //padding: const EdgeInsets.all(10),
          child: Chip(
            avatar: _uikChipsProps.avatar,
            label: Text(_uikChipsProps.text),
            elevation: 10,
            labelPadding: EdgeInsets.all(_uikChipsProps.padding),
            // labelStyle: TextStyle(color: textColor, fontSize: 20),
            onDeleted: () {},
            deleteIcon: _uikChipsProps.deleteIcon,
            deleteIconColor: Colors.yellow,
            backgroundColor: _uikChipsProps.backgroundColor,
            //shape: StadiumBorder(side: BorderSide(color: Colors.black)),
            shape: RoundedRectangleBorder(
              borderRadius: BorderRadius.only(
                  topRight: Radius.circular(10),
                  bottomRight: Radius.circular(10),
                  topLeft: Radius.circular(10),
                  bottomLeft: Radius.circular(10)),
            ),
          ),
        ),
      ],
    );
  }
}
//   @override
//   Widget build(BuildContext context) {
//     return MaterialApp(
//       home: Scaffold(
//         body: Container(
//           //alignment: Alignment.topCenter,
//           //margin: EdgeInsets.only(top: 20),
//           child: Chip(
//             avatar: leftElement,
//             label: Text(text),
//             elevation: 5,
//             labelStyle: TextStyle(color: textColor, fontSize: 20),
//             onDeleted: (rightElement != null) ? () {} : null,
//             deleteIcon: (rightElement != null) ? rightElement : null,
//             backgroundColor:
//                 (backgroundColor != null) ? backgroundColor : Colors.white,
//             //shape: StadiumBorder(side: BorderSide(color: Colors.black)),
//             shape: const RoundedRectangleBorder(
//               borderRadius: BorderRadius.only(
//                   topRight: Radius.circular(10),
//                   bottomRight: Radius.circular(10),
//                   topLeft: Radius.circular(10),
//                   bottomLeft: Radius.circular(10)),
//             ),
//             padding: EdgeInsets.all(12),
//           ),
//         ),
//       ),
//     );
//   }
// }
