import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikImageProps.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:flutter/material.dart';

class UikIcon extends UikWidget {
  WidgetType _widgetType;
  UikIconProps _UikIconProps;
  UikIcon(this._widgetType, this._UikIconProps)
      : super(_widgetType, _UikIconProps);

@override
  _UikIconState createState() => _UikIconState(_UikIconProps);
}

class _UikIconState extends State<UikIcon> {
  UikIconProps _UikIconProps;
  _UikIconState(this._UikIconProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.all(_UikIconProps.padding),
      child: Container(
        decoration: (_UikIconProps.wid != 0.0)
            ? BoxDecoration(
                color: _UikIconProps.backgroundColor,
                borderRadius: (_UikIconProps.rad != null)
                    ? BorderRadius.circular(_UikIconProps.rad)
                    : null,
                border: (_UikIconProps.wid != null)
                    ? Border.all(
                        color: _UikIconProps.borderColor,
                        width: _UikIconProps.wid,
                      )
                    : null,
              )
            : null,
        child: Icon(
          _UikIconProps.iconVal,
          size: _UikIconProps.iconSize,
          color: _UikIconProps.iconColor,
        ),
      ),
    );
  }
}
