import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikImageProps.dart';
import 'package:flutter/material.dart';

class UikImage extends UikWidget {
  WidgetType _widgetType;
  UikImageProps _uikImageProps;
  UikImage(this._widgetType, this._uikImageProps)
      : super(_widgetType, _uikImageProps);

  @override
  _UikImageState createState() => _UikImageState(_uikImageProps);
}

class _UikImageState extends State<UikImage> {
  UikImageProps _uikImageProps;
  _UikImageState(this._uikImageProps);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: EdgeInsets.only(
        top: _uikImageProps.marginTop,
        left: _uikImageProps.marginLeft,
        right: _uikImageProps.marginRight,
      ),
      child: Column(
        crossAxisAlignment: (_uikImageProps.isCenter == true)
            ? CrossAxisAlignment.center
            : CrossAxisAlignment.start,
        children: [
          Container(
            child: Image(
              image: NetworkImage(_uikImageProps.src),
              height: _uikImageProps.height,
              width: _uikImageProps.width,
              fit: _uikImageProps.iFit,
            ),
            decoration: BoxDecoration(
              borderRadius: (_uikImageProps.rad != null)
                  ? BorderRadius.circular(_uikImageProps.rad)
                  : null,
              border: (_uikImageProps.wid != null)
                  ? Border.all(
                      color: _uikImageProps.borderColor,
                      width: _uikImageProps.wid,
                    )
                  : null,
            ),
          ),
        ],
      ),
    );
  }
}
