import 'package:ui_sdk/components/UikButton.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikPopoverProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/components/UikButton.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikPopoverProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:popover/popover.dart';

class UikPopover extends UikWidget {
  WidgetType _widgetType;
  UikPopoverProps _uikPopoverProps;
  UikPopover(this._widgetType, this._uikPopoverProps)
      : super(_widgetType, _uikPopoverProps);

  @override
  _UikPopoverState createState() => _UikPopoverState(_uikPopoverProps);
}

class _UikPopoverState extends State<UikPopover> {
  UikPopoverProps _uikPopoverProps;
  _UikPopoverState(this._uikPopoverProps);

  void Popover(BuildContext context) {
    showPopover(
      context: context,
      bodyBuilder: (context) {
        return ListView(
          shrinkWrap: true,
          padding: const EdgeInsets.all(16),
          children: [
            //FOR IMAGE
            if (_uikPopoverProps.imageSrc != null) ...[
              Container(
                margin: const EdgeInsets.fromLTRB(0, 0, 0, 10),
                width: 279,
                height: 180,
                decoration: BoxDecoration(
                  image: DecorationImage(
                    image: NetworkImage(_uikPopoverProps.imageSrc!),
                    fit: BoxFit.fill,
                  ),
                  borderRadius: BorderRadius.all(Radius.circular(8)),
                ),
              )
            ],

            //FOR HEADLINE AND DESC
            Container(
              width: 310,
              child: InkWell(
                onTap: () {
                  Navigator.of(context).pop();
                },
                child: Column(children: [
                  if (_uikPopoverProps.description != null) ...[
                    Container(
                        width: 279,
                        height: 70,
                        child: Column(
                          children: [
                            Container(
                                child: Text(
                              _uikPopoverProps.headline,
                              style: GoogleFonts.poppins(
                                  textStyle:
                                      Theme.of(context).textTheme.headline4,
                                  fontSize: 24,
                                  fontWeight: FontWeight.w600,
                                  color: Colors.black),
                            )),
                            Container(
                                child: Text(
                              _uikPopoverProps.description!,
                              style: GoogleFonts.poppins(
                                textStyle:
                                    Theme.of(context).textTheme.headline4,
                                fontSize: 16,
                                fontWeight: FontWeight.w600,
                              ),
                            ))
                          ],
                        ))
                  ] else ...[
                    Container(
                      width: 279,
                      height: 55,
                      child: Center(
                        child: Text(
                          _uikPopoverProps.headline,
                          style: GoogleFonts.poppins(
                              textStyle: Theme.of(context).textTheme.headline4,
                              fontSize: 24,
                              fontWeight: FontWeight.w600,
                              color: Colors.black),
                        ),
                      ),
                    )
                  ]
                ]),
              ),
            ),

            // FOR TEXTFIELD
            if (_uikPopoverProps.textfieldData != null) ...[
              Container(
                width: 279,
                height: 64,
                // color: const Color(0xfff5f5f5),
                decoration: const BoxDecoration(
                    color: Color(0xfff5f5f5),
                    borderRadius: BorderRadius.all(Radius.circular(8))),
                padding: const EdgeInsets.fromLTRB(16, 20, 16, 20),
                margin: const EdgeInsets.fromLTRB(0, 10, 0, 0),
                child: TextField(
                  style: GoogleFonts.poppins(
                      fontSize: 16, fontWeight: FontWeight.w400),
                  decoration: InputDecoration(
                    border: InputBorder.none,
                    labelText: _uikPopoverProps.textfieldData!,
                    floatingLabelBehavior: FloatingLabelBehavior.never,
                  ),
                ),
              )
            ],

            //NUMBER OF BUTTONS
            for (var i = 0; i < _uikPopoverProps.buttonArray!.length; i++)
              Container(
                width: 279,
                height: 64,
                margin: const EdgeInsets.fromLTRB(0, 10, 0, 0),
                decoration: const BoxDecoration(
                  borderRadius: BorderRadius.all(Radius.circular(8)),
                ),
                child: Text(_uikPopoverProps.buttonArray[i]["text"]),
                color: Color(_uikPopoverProps.buttonArray[i]["color"]),
              )
          ],
        );
      },
      width: 310,
      arrowDxOffset: 10,
      constraints: BoxConstraints(maxHeight: 600),
    );
  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    throw UnimplementedError();
  }
}
