import 'package:ui_sdk/components/UikImage.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikProductPageContainerProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

import '../props/UikProductPagePaginationProps.dart';

class UikProductPageContainer extends UikWidget {
  WidgetType _widgetType;
  UikProductPageContainerProps _uikProductPageContainerProps;
  UikProductPageContainer(this._widgetType, this._uikProductPageContainerProps)
      : super(_widgetType, _uikProductPageContainerProps);

  @override
  _UikProductPageContainerState createState() =>
      _UikProductPageContainerState(_uikProductPageContainerProps);
}

class _UikProductPageContainerState extends State<UikProductPageContainer> {
  UikProductPageContainerProps _uikProductPageContainerProps;
  _UikProductPageContainerState(this._uikProductPageContainerProps);

  @override
  Widget build(BuildContext context) {
    return Container(
        width: 375,
        height: 280,
        color: const Color(0xFFF5F5F5),
        child: Padding(
          padding: const EdgeInsets.only(left: 10.0, top: 24),
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            mainAxisAlignment: MainAxisAlignment.spaceEvenly,
            children: [
              _uikProductPageContainerProps.price!,
              _uikProductPageContainerProps.desc!,
              _uikProductPageContainerProps.tagRow!,
              _uikProductPageContainerProps.addCartButton!
            ],
          ),
        ));
  }
}
