import 'dart:ui';

import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikScrollOrderAgainProductProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

class UikScrollOrderAgainProduct extends UikWidget {
  WidgetType _widgetType;
  UikScrollOrderAgainProductProps _UikScrollOrderAgainProductProps;
  UikScrollOrderAgainProduct(
      this._widgetType, this._UikScrollOrderAgainProductProps)
      : super(_widgetType, _UikScrollOrderAgainProductProps);

  @override
  _UikScrollOrderAgainProductState createState() =>
      _UikScrollOrderAgainProductState(_UikScrollOrderAgainProductProps);
}

class MyCustomScrollBehavior extends MaterialScrollBehavior {
  // Override behavior methods and getters like dragDevices
  @override
  Set<PointerDeviceKind> get dragDevices => {
        PointerDeviceKind.touch,
        PointerDeviceKind.mouse,
        // etc.
      };
}

class _UikScrollOrderAgainProductState
    extends State<UikScrollOrderAgainProduct> {
  UikScrollOrderAgainProductProps _UikScrollOrderAgainProductProps;
  _UikScrollOrderAgainProductState(this._UikScrollOrderAgainProductProps);

  @override
  Widget build(BuildContext context) {
    return _UikScrollOrderAgainProductProps.ll!.length != null
        ? Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              Container(
                width: 97,
                height: 24,
                margin: EdgeInsets.only(left: 17, bottom: 11),
                child: Text(
                  "Order Again",
                  style: GoogleFonts.poppins(
                      fontSize: 15, fontWeight: FontWeight.w500),
                ),
              ),
              Container(
                width: 375,
                height: 155,
                child: ScrollConfiguration(
                  behavior: MyCustomScrollBehavior(),
                  child: ListView(
                    scrollDirection: Axis.horizontal,
                    children: [
                      for (int i = 0;
                          i < _UikScrollOrderAgainProductProps.ll!.length;
                          i = i + 2)
                        Container(
                          width: 153,
                          height: 130,
                          margin: EdgeInsets.only(right: 12, left: 16),
                          child: Column(
                            crossAxisAlignment: CrossAxisAlignment.start,
                            children: [
                              _UikScrollOrderAgainProductProps.ll![i],
                              const SizedBox(
                                height: 6,
                              ),
                              if (_UikScrollOrderAgainProductProps.ll!.length %
                                      2 !=
                                  0) ...[
                                if (i !=
                                    _UikScrollOrderAgainProductProps
                                            .ll!.length -
                                        1)
                                  _UikScrollOrderAgainProductProps.ll![i + 1],
                              ] else ...[
                                _UikScrollOrderAgainProductProps.ll![i + 1]
                              ],
                            ],
                          ),
                        ),
                    ],
                  ),
                ),
              ),
            ],
          )
        : Text("");
  }
}
