import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikImageProps.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;
import '../props/UikIconProps.dart';
import '../props/UikSearchProps.dart';
import '../utils/UikActionListner.dart';

class UikSearch extends UikWidget {
  WidgetType _widgetType;
  UikSearchProps _UikSearchProps;
  UikSearch(this._widgetType, this._UikSearchProps)
      : super(_widgetType, _UikSearchProps);

  @override
  _UikSearchState createState() => _UikSearchState(_UikSearchProps);
}

class _UikSearchState extends State<UikSearch>
    with SingleTickerProviderStateMixin {
  final myController = new TextEditingController();

  UikSearchProps _UikSearchProps;
  _UikSearchState(this._UikSearchProps);

  int hastype = 0;
  late AnimationController controller;
  textListener() async {
    if (myController.text.length == 3) {
      await executeUikWidgetAction(_UikSearchProps.action);
    }
  }

  @override
  void initState() {
    super.initState();
    myController.addListener(textListener);
    controller = AnimationController(
      vsync: this,
      duration: Duration(milliseconds: 400),
      reverseDuration: Duration(milliseconds: 400),
    );
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      width: _UikSearchProps.width,
      height: _UikSearchProps.height,

      margin: EdgeInsets.only(
        right: _UikSearchProps.rightMargin,
        left: _UikSearchProps.leftMargin,
        top: _UikSearchProps.topMargin,
        bottom: _UikSearchProps.bottomMargin,
      ),
      decoration: BoxDecoration(
        color: Colors.white,
        border: (_UikSearchProps.borderColor != null)
            ? Border.all(
                color: _UikSearchProps.borderColor!,
              )
            : null,
        borderRadius: BorderRadius.circular(_UikSearchProps.borderRadius),
        // color: Color(0xFFF5F5F5),
      ),

      // height: 200,
      child: Row(
        children: [
          (hastype > 0)
              ? Container(
                  margin: const EdgeInsets.fromLTRB(19, 0, 18, 0),
                  child: _UikSearchProps.frontArrowIcon,
                )
              : Container(
                  margin: const EdgeInsets.fromLTRB(19, 0, 12, 0),
                  child: _UikSearchProps.frontSearchIcon,
                ),

          //..................................................TextField..............................................//
          Flexible(
            child: InkWell(
              child: Container(
                margin: const EdgeInsets.fromLTRB(5, 0, 5, 2),
                child: TextField(
                  //onChanged: (e) {},
                  onTap: () async {
                    await executeUikWidgetAction(_UikSearchProps.action);
                  },
                  controller: myController,
                  decoration: InputDecoration.collapsed(
                    hintText: _UikSearchProps.label,
                    hintStyle: TextStyle(
                      fontSize: _UikSearchProps.labelFontSize,
                      fontWeight: FontWeight.w400,
                    ),
                  ),
                  style: const TextStyle(color: Colors.black),
                ),
              ),
            ),
          ),

          if (_UikSearchProps.micIcon == true) ...[
            Container(
              child: _UikSearchProps.rightIcon,
              margin: const EdgeInsets.fromLTRB(22, 14, 22, 14),
            ),
          ],
        ],
      ),
    );
  }
}
