// dog_card.dart

import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikSnackBarProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';

class UikSnackBar extends UikWidget {
  WidgetType _widgetType;
  UikSnackBarProps _uikSnackBarProps;
  UikSnackBar(this._widgetType, this._uikSnackBarProps)
      : super(_widgetType, _uikSnackBarProps);

  @override
  _UikSnackBarState createState() => _UikSnackBarState(_uikSnackBarProps);
}

class _UikSnackBarState extends State<UikSnackBar> {
  UikSnackBarProps _uikSnackBarProps;
  _UikSnackBarState(this._uikSnackBarProps);

  SnackBar snackWidget() {
    final snackBar = SnackBar(
      content: Container(
        height: 50,
        child: Row(
          children: [
            Container(
              child: (_uikSnackBarProps.leftElement != null)
                  ? _uikSnackBarProps.leftElement
                  : null,
              height: 40,
            ),

            SizedBox(width: 10),
            Container(
              height: 40,
              child: _uikSnackBarProps.description != null
                  ? Column(
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: [
                        Text(
                          _uikSnackBarProps.title,
                          style: TextStyle(fontSize: 20),
                        ),
                        // if (description != null)
                        Text(
                          _uikSnackBarProps.description,
                          style: TextStyle(fontSize: 12, color: Colors.grey),
                        ),
                      ],
                    )
                  : Text(
                      _uikSnackBarProps.title,
                      style: TextStyle(fontSize: 28),
                    ),
            ),
            // SizedBox(width: 120),
            Spacer(),
            Container(
                //.................Trigger ko badme laga denge...............
                // child: Trigger,
                )
          ],
        ),
      ),
      backgroundColor: _uikSnackBarProps.backgroundColor,
      behavior: SnackBarBehavior.floating,
      width: 300,
      duration: Duration(milliseconds: 5000),
      // action: SnackBarAction(
      //   label: "Action",
      //   disabledTextColor: Colors.white,
      //   textColor: Colors.yellow,
      //   onPressed: () {
      //     //function
      //   },
      // ),
    );
    return snackBar;
  }

  @override
  Widget build(BuildContext context) {
    return Center();
  }
}
