import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikStackedImageProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

class UikStackedImage extends UikWidget {
  WidgetType _widgetType;
  UikStackedImageProps _uikStackedImageProps;
  UikStackedImage(this._widgetType, this._uikStackedImageProps)
      : super(_widgetType, _uikStackedImageProps);

  @override
  _UikStackedImageState createState() =>
      _UikStackedImageState(_uikStackedImageProps);
}

class _UikStackedImageState extends State<UikStackedImage> {
  UikStackedImageProps _uikStackedImageProps;
  _UikStackedImageState(this._uikStackedImageProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      width: _uikStackedImageProps.width,
      height: _uikStackedImageProps.height,
      margin: EdgeInsets.only(
          top: _uikStackedImageProps.topMargin,
          left: _uikStackedImageProps.leftMargin,
          right: _uikStackedImageProps.rightMargin,
          bottom: _uikStackedImageProps.bottomMargin),
      decoration: BoxDecoration(
        borderRadius: BorderRadius.only(
          topLeft: Radius.circular(_uikStackedImageProps.topLeftRadius),
          topRight: Radius.circular(_uikStackedImageProps.topRightRadius),
          bottomLeft: Radius.circular(_uikStackedImageProps.bottomLeftRadius),
          bottomRight: Radius.circular(_uikStackedImageProps.bottomRightRadius),
        ),
        image: DecorationImage(
          fit: BoxFit.cover,
          image: NetworkImage(
            _uikStackedImageProps.url,
          ),
        ),
      ),
    );
  }
}
