// dog_card.dart

import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';

import '../props/UikTabBarProps.dart';

class UikTabBar extends UikWidget {
  WidgetType _widgetType;
  UikTabBarProps _UikTabBarProps;
  UikTabBar(this._widgetType, this._UikTabBarProps)
      : super(_widgetType, _UikTabBarProps);

  @override
  _UikTabBarState createState() => _UikTabBarState(_UikTabBarProps);
}

class _UikTabBarState extends State<UikTabBar> with TickerProviderStateMixin {
  UikTabBarProps _UikTabBarProps;
  _UikTabBarState(this._UikTabBarProps);

  late TabController _tabController;
  @override
  void initState() {
    super.initState();
    _tabController =
        TabController(length: _UikTabBarProps.ll.length, vsync: this);
  }

  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        Container(
          
          width: 400,
          // width: 300,
           height: 80.0,
          //  padding: const EdgeInsets.all(16),
          //color: Colors.pink,
          margin: EdgeInsets.only(
            top: _UikTabBarProps.topMargin,
          ),
          decoration: BoxDecoration(
            border: (_UikTabBarProps.isBorder == true) ? Border.all() : null,
            borderRadius: BorderRadius.circular(10),
            color: _UikTabBarProps.backgroundColor,
          ),
          child: TabBar(
            physics: NeverScrollableScrollPhysics(),
            indicatorColor: _UikTabBarProps.indicatorColor,
            labelColor: Colors.black,
            unselectedLabelColor: Colors.grey,
            controller: _tabController,
            tabs: <Widget>[
              for (int i = 0; i < _UikTabBarProps.ll.length; i++) ...[
                Tab(
                  icon: _UikTabBarProps.ll[i],
                  // Icon(
                  //   _UikTabBarProps.ll[i],
                  //   size: _UikTabBarProps.iconSize,
                  // ),
                  // UikIcon(
                  //   valIcon: ll[i],
                  //   iconSize: widget.iconSize,
                  // ),
                )
              ],
            ],
          ),
        ),
      ],
    );
  }
}
