import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTagsProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

class UikTags extends UikWidget {
  WidgetType _widgetType;
  UikTagsProps _uikTagsProps;
  UikTags(this._widgetType, this._uikTagsProps)
      : super(_widgetType, _uikTagsProps);

  @override
  _UikTagsState createState() => _UikTagsState(_uikTagsProps);
}

class _UikTagsState extends State<UikTags> {
  UikTagsProps _uikTagsProps;
  _UikTagsState(this._uikTagsProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      child: MouseRegion(
        cursor: SystemMouseCursors.click,
        child: InkWell(
          onTap: () {
            print("Button is cliked");
          },
          child: Container(
            width: _uikTagsProps.width,
            height: _uikTagsProps.height,
            decoration: BoxDecoration(
              // ignore: unnecessary_null_comparison
              border: (_uikTagsProps.borderColor != null)
                  ? Border.all(color: _uikTagsProps.borderColor!)
                  : null,
              borderRadius: BorderRadius.circular(4),
              color: _uikTagsProps.backgroundColor,
            ),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.center,
              crossAxisAlignment: CrossAxisAlignment.center,
              children: [
                Column(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: [
                    Container(child: _uikTagsProps.avatar),
                  ],
                ),
                if (_uikTagsProps.avatar != null) ...[
                  const SizedBox(width: 8),
                ],
                _uikTagsProps.text!,
              ],
            ),
          ),
        ),
      ),
    );
  }
}
