import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTextChipListProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

class UikTextChipList extends UikWidget {
  final WidgetType _widgetType;
  final UikTextChipListProps _uikTextChipListProps;
  UikTextChipList(this._widgetType, this._uikTextChipListProps)
      : super(_widgetType, _uikTextChipListProps);

  @override
  _UikTextChipListState createState() =>
      _UikTextChipListState(_uikTextChipListProps);
}

class _UikTextChipListState extends State<UikTextChipList> {
  final UikTextChipListProps _uikTextChipListProps;
  _UikTextChipListState(this._uikTextChipListProps);

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      height: 60.0,
      width: MediaQuery.of(context).size.width - 32,
      child: ListView.builder(
        physics: const BouncingScrollPhysics(),
        shrinkWrap: true,
        scrollDirection: Axis.horizontal,
        itemCount: _uikTextChipListProps.children.length,
        itemBuilder: (context, index) {
          return _uikTextChipListProps.children[index];
        },
      ),
    );
  }
}
