import 'package:ui_sdk/models/emptyBagItem.dart';
import 'package:ui_sdk/models/emptySdkObject.dart';
import 'package:ui_sdk/models/emptyWidgetObject.dart';
import 'package:flutter/material.dart';

Map<String, dynamic> cartConvertor(dynamic body) {
  
  int numberOfItems = body['cart']['lineItems'].length;
  int count = 0;
  double total = 0.0;
  for (int i = 0; i < numberOfItems; i++) {
    //extracting fields from the body
    String imageUrl = body['cart']['lineItems'][i]['mediaItem']['url'];
    String totalPrice = body['cart']['lineItems'][i]['totalPrice'];
    String name = body['cart']['lineItems'][i]['name'];

    total += double.parse(totalPrice);
    //generating emptyBagItem
    emptyBagItem["productPrice"] = totalPrice;
    emptyBagItem["imageUrl"] = imageUrl;
    emptyBagItem["productDescription"] = name;

    //inserting EmptyBag Item in datastore
    cartDataStore["titleBagItem${i}"] = emptyBagItem;

    //generating emptyWidget Object
    emptyWidgetObject["id"] = "titleBagItem${i}";
    emptyWidgetObject["uiType"] = "UikBagItem";

    //inserting emptyWidgetObject in cartWidgets
    count++;
    cartWidget.insert(count,emptyWidgetObject);
  }

  cartDataStore["titleCartTextHorizontal"]!["totalPrice"] = total;

  emptySdkObject["widgets"] = cartWidget;
  emptySdkObject["dataStore"] = cartDataStore;


  print(emptySdkObject);
  return emptySdkObject;
}

var cartDataStore = {
  "titleCartTextHorizontal": {
    "id": "titleCartTextHorizontal",
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "titleTextField": {
    "id": "titleTextField",
    "width": 370.0,
    "height": 66.0,
    "rightElement": {
      "id": "titleIcon",
      "iconVal": "0xef28",
      "iconColor": "0xFF212121",
      "iconSize": "20.0",
      "padding": "22.0",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "titleText": {
    "id": "titleText",
    "text": "bag",
    "size": "32.0",
    "fontWeight": FontWeight.w600,
    "leftMargin": 16.0,
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "titleButton": {
     "id": "titleButton",
     "widthSize": "370",
      "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },

  //tabbar
     "titleTabBar": {
      "id": "titleTabBar",
      "ll": [
        {
          "id": "titleIcon",
          "iconVal": "0xf107",
          "backgroundColor": "0xFFFFFFFF",
          "padding": "0.0",
          "iconSize": "27.0",
          "action": {
            "tap": {
              "type": "UIK_OPEN_WEB",
              "data": {
                "url": "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
              }
            }
          }
        },
        {
          "id": "titleIcon",
          "iconVal": "0xe59c",
          "backgroundColor": "0xFFFFFFFF",
          "padding": "0.0",
          "iconSize": "27.0",
          "action": {
            "tap": {
              "type": "UIK_OPEN_WEB",
              "data": {
                "url": "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
              }
            }
          }
        },
       
      
        {
          "id": "titleIcon",
          "iconVal": "0xf36e",
          "backgroundColor": "0xFFFFFFFF",
          "padding": "0.0",
          "iconSize": "27.0",
          "action": {
            "tap": {
              "type": "UIK_OPEN_WEB",
              "data": {
                "url": "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
              }
            }
          }
        },
          {
          "id": "titleIcon",
          "iconVal": "0xf0063",
          "backgroundColor": "0xFFFFFFFF",
          "padding": "0.0",
          "iconSize": "27.0",
          "action": {
            "tap": {
              "type": "UIK_OPEN_WEB",
              "data": {
                "url": "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
              }
            }
          }
        },
      ],
      "backgroundColor": "0xFFFFFFFF",
      "indicatorColor": "0xFF212121",
      "topMargin": "18.74",
      "isBorder": "false"
    },
  "titleText2": {
    "id": "titleText2",
    "text": "promocode",
    "size": "24.0",
    "leftMargin": 16.0,
    "fontWeight": FontWeight.w600,
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
};


var cartWidget = [
    {"id": "titleText", "uiType": "UikText"},
    {"id": "titleText2", "uiType": "UikText"},
    {"id": "titleTextField", "uiType": "UikTextField"},
    {"id": "titleCartTextHorizontal", "uiType": "UikCartTextHorizontal"},
    {"id": "titleButton" , "uiType": "UikButton"},
    {"id": "titleTabBar" , "uiType": "UikTabBar"}
];