import 'package:ui_sdk/components/UikStackedImage.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikHomeCardEightProps.dart';
import 'package:ui_sdk/props/UikStackedImageProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import '../../components/UikContainerText.dart';
import '../../components/UikText.dart';
import '../../components/WidgetType.dart';
import '../../props/UikContainerTextProps.dart';

UikHomeCardEightProps $UikHomeCardEightPropsFromJson(
    Map<String, dynamic> json) {
  final UikHomeCardEightProps uikHomeCardEightProps = UikHomeCardEightProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikHomeCardEightProps.id = id;
  }

  final String? badgeText = jsonConvert.convert<String>(json['badgeText']);
  if (badgeText != null) {
    uikHomeCardEightProps.badgeText = UikContainerText(
        WidgetType.UikText, UikContainerTextProps.fromJson(json['badgeText']));
  }

  final String? text = jsonConvert.convert<String>(json['text']);
  if (text != null) {
    uikHomeCardEightProps.text = UikContainerText(
        WidgetType.UikText, UikContainerTextProps.fromJson(json['text']));
  }

  final String? image = jsonConvert.convert<String>(json['image']);
  if (image != null) {
    uikHomeCardEightProps.image = UikStackedImage(
      WidgetType.UikText,
      UikStackedImageProps.fromJson(
        json['image'],
      ),
    );
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikHomeCardEightProps.action = action;
  }
  return uikHomeCardEightProps;
}
