import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikChipsProps.dart';
import 'package:ui_sdk/props/UikShortAndFilterProps.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:flutter/material.dart';
import 'package:ui_sdk/props/UikTextProps.dart';

import '../../components/UikAvatar.dart';
import '../../components/UikButton.dart';
import '../../components/WidgetType.dart';
import '../../props/UikAvatarProps.dart';

UikShortAndFilterProps $UikShortAndFilterPropsFromJson(
    Map<String, dynamic> json) {
  final UikShortAndFilterProps uikShortAndFilterProps =
      UikShortAndFilterProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikShortAndFilterProps.id = id;
  }

  final double? leftMargin = jsonConvert.convert<double>(json['leftMargin']);
  if (leftMargin != null) {
    uikShortAndFilterProps.leftMargin = leftMargin;
  }

  final double? rightMargin = jsonConvert.convert<double>(json['rightMargin']);
  if (rightMargin != null) {
    uikShortAndFilterProps.rightMargin = rightMargin;
  }

  final double? topMargin = jsonConvert.convert<double>(json['topMargin']);
  if (topMargin != null) {
    uikShortAndFilterProps.topMargin = topMargin;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json['bottomMargin']);
  if (bottomMargin != null) {
    uikShortAndFilterProps.bottomMargin = bottomMargin;
  }

  final String? filter = jsonConvert.convert<String>(json['filter']);
  if (filter != null) {
    uikShortAndFilterProps.filter =
        UikButton(WidgetType.UikText, UikButtonProps.fromJson(json['filter']));
  }
  final String? short = jsonConvert.convert<String>(json['short']);
  if (short != null) {
    uikShortAndFilterProps.short =
        UikButton(WidgetType.UikText, UikButtonProps.fromJson(json['short']));
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikShortAndFilterProps.action = action;
  }

  return uikShortAndFilterProps;
}
