import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/cupertino.dart';
import 'package:ui_sdk/utils/extensions.dart';

import '../../props/UikAvatarProps.dart';

UikAvatarProps $UikAvatarPropsFromJson(Map<String, dynamic> json) {
  final UikAvatarProps uikAvatarProps = UikAvatarProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikAvatarProps.id = id;
  }
  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikAvatarProps.action = action;
  }
  final String? backgroundImage =
      jsonConvert.convert<String>(json['backgroundImage']);
  if (backgroundImage != null) {
    uikAvatarProps.backgroundImage = backgroundImage;
  }

  final String? backgroundColor =
      jsonConvert.convert<String>(json['backgroundColor']);
  if (backgroundColor != null) {
    uikAvatarProps.backgroundColor = backgroundColor.toColor();
  }

  final String? shape = jsonConvert.convert<String>(json['shape']);
  if (shape != null) {
    uikAvatarProps.shape =
        BoxShape.values.firstWhere((e) => e.toString() == shape);
  }
  final double? borderRadius =
      jsonConvert.convert<double>(json['borderRadius']);
  if (borderRadius != null) {
    uikAvatarProps.borderRadius = borderRadius;
  }

  //not in use
  final String? size = jsonConvert.convert<String>(json['size']);
  if (size != null) {
    if (size == "UikSize.SMALL") {
      uikAvatarProps.size = 20.0;
    }
  }

  final double? width = jsonConvert.convert<double>(json['width']);
  if (width != null) {
    uikAvatarProps.width = width;
  }

  final double? height = jsonConvert.convert<double>(json['height']);
  if (height != null) {
    uikAvatarProps.height = height;
  }

  final double? padding = jsonConvert.convert<double>(json['padding']);
  if (padding != null) {
    uikAvatarProps.padding = padding;
  }
  return uikAvatarProps;
}
