import 'dart:ui';

import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikButton.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/utils/extensions.dart';

import '../../components/UikIcon.dart';
import '../../components/WidgetType.dart';
import '../../props/UikIconProps.dart';

import '../../components/UikIcon.dart';
import '../../components/WidgetType.dart';
import '../../props/UikIconProps.dart';
import '../../props/UikTextProps.dart';

UikButtonProps $UikButtonPropsFromJson(Map<String, dynamic> json) {
  final UikButtonProps uikButtonProps = UikButtonProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikButtonProps.id = id;
  }
  final String? text = jsonConvert.convert<String>(json['text']);
  if (text != null) {
    uikButtonProps.text =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['text']));
  }
  // final FontWeight? textWeight =
  //     jsonConvert.convert<FontWeight>(json['textWeight']);
  // if (textWeight != null) {
  //   uikButtonProps.textWeight = textWeight;
  // }
  final String? textWeight = jsonConvert.convert<String>(json['textWeight']);
  if (textWeight != null) {
    if (textWeight == "FontWeight.bold") {
      uikButtonProps.textWeight = FontWeight.bold;
    }
    if (textWeight == "FontWeight.w100") {
      uikButtonProps.textWeight = FontWeight.w100;
    }
    if (textWeight == "FontWeight.w200") {
      uikButtonProps.textWeight = FontWeight.w200;
    }
    if (textWeight == "FontWeight.w300") {
      uikButtonProps.textWeight = FontWeight.w300;
    }
    if (textWeight == "FontWeight.w400") {
      uikButtonProps.textWeight = FontWeight.w400;
    }
    if (textWeight == "FontWeight.w500") {
      uikButtonProps.textWeight = FontWeight.w500;
    }
    if (textWeight == "FontWeight.w600") {
      uikButtonProps.textWeight = FontWeight.w600;
    }
    if (textWeight == "FontWeight.w700") {
      uikButtonProps.textWeight = FontWeight.w700;
    }
    if (textWeight == "FontWeight.w800") {
      uikButtonProps.textWeight = FontWeight.w800;
    }
    if (textWeight == "FontWeight.w900") {
      uikButtonProps.textWeight = FontWeight.w900;
    }
  }
  final String? borderColor = jsonConvert.convert<String>(json['borderColor']);
  if (borderColor != null) {
    uikButtonProps.borderColor = borderColor.toColor();
  }
  final String? textColor = jsonConvert.convert<String>(json['textColor']);
  if (textColor != null) {
    uikButtonProps.textColor = textColor.toColor();
  }
  String? backgroundColor =
      jsonConvert.convert<String>(json['backgroundColor']);
  if (backgroundColor != null) {
    uikButtonProps.backgroundColor = backgroundColor.toColor();
  }
  final String? onClick = jsonConvert.convert<String>(json['onClick']);
  // if (onClick != null) {
  //   uikButtonProps.onClick = onClick;
  // }
  // widthSize will be deducted from the screen size
  final double? widthSize = jsonConvert.convert<double>(json['widthSize']);
  if (widthSize != null) {
    uikButtonProps.widthSize = widthSize;
  } else {
    uikButtonProps.widthSize = 0.0;
  }

  final double? heightSize = jsonConvert.convert<double>(json['heightSize']);
  if (heightSize != null) {
    uikButtonProps.heightSize = heightSize;
  }
  final double? textSize = jsonConvert.convert<double>(json['textSize']);
  if (textSize != null) {
    uikButtonProps.textSize = textSize;
  }

  final double? borderRadius =
      jsonConvert.convert<double>(json['borderRadius']);
  if (borderRadius != null) {
    uikButtonProps.borderRadius = borderRadius;
  }
  final String? leftElement = jsonConvert.convert<String>(json['leftElement']);
  if (leftElement != null) {
    uikButtonProps.leftElement =
        UikIcon(WidgetType.UikText, UikIconProps.fromJson(json['leftElement']));
  }
  final String? rightElement =
      jsonConvert.convert<String>(json['rightElement']);
  if (rightElement != null) {
    uikButtonProps.rightElement = UikIcon(
        WidgetType.UikText, UikIconProps.fromJson(json['rightElement']));
  }
  final double? leftMargin = jsonConvert.convert<double>(json['leftMargin']);
  if (leftMargin != null) {
    uikButtonProps.leftMargin = leftMargin;
  }

  final double? rightMargin = jsonConvert.convert<double>(json['rightMargin']);
  if (rightMargin != null) {
    uikButtonProps.rightMargin = rightMargin;
  }

  final double? topMargin = jsonConvert.convert<double>(json['topMargin']);
  if (topMargin != null) {
    uikButtonProps.topMargin = topMargin;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json['bottomMargin']);
  if (bottomMargin != null) {
    uikButtonProps.bottomMargin = bottomMargin;
  }

  final bool? isCenter = jsonConvert.convert<bool>(json['isCenter']);
  if (isCenter != null) {
    uikButtonProps.isCenter = isCenter;
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikButtonProps.action = action;
  }
  return uikButtonProps;
}
