import 'package:ui_sdk/components/UikButton.dart';
import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:ui_sdk/props/UikReviewProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';

import 'package:flutter/widgets.dart';

import '../../components/UikAvatar.dart';
import '../../components/UikImage.dart';
import '../../components/UikNavbar.dart';
import '../../components/UikRating.dart';
import '../../components/UikSearch.dart';
import '../../components/UikStackImageIcon.dart';
import '../../components/UikStackedImage.dart';
import '../../components/UikTextArea.dart';
import '../../props/UikAvatarProps.dart';
import '../../props/UikImageProps.dart';
import '../../props/UikNavbarProps.dart';
import '../../props/UikRatingProps.dart';
import '../../props/UikSearchProps.dart';
import '../../props/UikStackImageIconProps.dart';
import '../../props/UikStackedImageProps.dart';
import '../../props/UikTextAreaProps.dart';

UikReviewProps $UikReviewPropsFromJson(Map<String, dynamic> json) {
  final UikReviewProps uikReviewProps = UikReviewProps();

  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikReviewProps.id = id;
  }
  final String? datetext = jsonConvert.convert<String>(json['datetext']);
  if (datetext != null) {
    uikReviewProps.datetext =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['datetext']));
  }

  final String? nametext = jsonConvert.convert<String>(json['nametext']);
  if (nametext != null) {
    uikReviewProps.nametext =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['nametext']));
  }

  final String? dectext = jsonConvert.convert<String>(json['dectext']);
  if (dectext != null) {
    uikReviewProps.dectext =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['dectext']));
  }

  final String? review = jsonConvert.convert<String>(json['Review']);
  if (review != null) {
    uikReviewProps.review =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['Review']));
  }
  final String? rating = jsonConvert.convert<String>(json['rating']);
  if (rating != null) {
    uikReviewProps.rating =
        UikRating(WidgetType.UikText, UikRatingProps.fromJson(json['rating']));
  }

  final String? avatar = jsonConvert.convert<String>(json['avatar']);
  if (avatar != null) {
    uikReviewProps.avatar =
        UikAvatar(WidgetType.UikText, UikAvatarProps.fromJson(json['avatar']));
  }

  final String? image = jsonConvert.convert<String>(json['image']);
  if (image != null) {
    uikReviewProps.image = UikStackedImage(
        WidgetType.UikText, UikStackedImageProps.fromJson(json['image']));
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikReviewProps.action = action;
  }
  return uikReviewProps;
}

class UiKImage {}
