import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';

import '../../components/UikIcon.dart';
import '../../components/WidgetType.dart';
import '../../props/UikIconProps.dart';
import '../../props/UikSnackBarProps.dart';

UikSnackBarProps $UikSnackBarPropsFromJson(Map<String, dynamic> json) {
  final UikSnackBarProps uikSnackBarProps = UikSnackBarProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikSnackBarProps.id = id;
  }

  final String? title = jsonConvert.convert<String>(json['title']);
  if (title != null) {
    uikSnackBarProps.title = title;
  }

  final String? description = jsonConvert.convert<String>(json['description']);
  if (description != null) {
    uikSnackBarProps.description = description;
  }

  final String? backgroundColor =
      jsonConvert.convert<String>(json['backgroundColor']);
  if (backgroundColor != null) {
    uikSnackBarProps.backgroundColor = Color(int.parse(backgroundColor));
  }

  final String? leftElement = jsonConvert.convert<String>(json['leftElement']);
  if (leftElement != null) {
    uikSnackBarProps.leftElement =
        UikIcon(WidgetType.UikText, UikIconProps.fromJson(json['leftElement']));
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikSnackBarProps.action = action;
  }
  return uikSnackBarProps;
}
