import 'dart:convert';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_button_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import 'WidgetProps.dart';

@JsonSerializable()
class UikButtonProps extends WidgetProps {
  late String id;
  late Widget? text = null;
  late Color borderColor = Color(0xFFFFD60A);
  late Color backgroundColor = Color(0xFFFFD60A);
  late double? borderRadius = 8.0;
  late Color textColor = Color(0xFF212121);
  // late double? widthSize = 343.0;
  late double widthSize = 0.0;
  late double? heightSize = 0.0;
  late double textSize = 14.0;
  late FontWeight textWeight = FontWeight.bold;
  late Widget? leftElement = null;
  late Widget? rightElement = null; //Icon(Icons.close);
  late String type = "primary";
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;
  late double topMargin = 0.0;
  late double bottomMargin = 0.0;
  //late String onClick;
  late bool isStuck = true;
  late bool isCenter = false;
  late UikAction action;

  UikButtonProps();

  factory UikButtonProps.fromJson(Map<String, dynamic> json) =>
      $UikButtonPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
