import 'dart:convert';
import 'dart:ui';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_text_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:flutter/material.dart';

import '../generated/json/uik_containertext_props.g.dart';
import '../generated/json/uik_divider_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikContainerTextProps extends WidgetProps {
  late String id;
  late UikAction action;
  late String text = "";
  late String striketext = "";
  late double width = 0.0;
  late double height = 0.0;
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;
  late double topMargin = 0.0;
  late double bottomMargin = 0.0;
  late FontWeight? normalFontWeight = FontWeight.bold;
  late FontWeight? strikenFontWeight = FontWeight.normal;
  late TextAlign? textalign = TextAlign.justify;
  late String fontFamily = "Poppins";
  late double size = 20.0;
  late Color color = Colors.black;
  late bool isCenter = false;
  late bool isStrike = false;

  UikContainerTextProps();

  factory UikContainerTextProps.fromJson(Map<String, dynamic> json) =>
      $UikContainerTextPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
