import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_image_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/generated/json/uik_icon_props.g.dart';

import 'WidgetProps.dart';

@JsonSerializable()
class UikIconProps extends WidgetProps {
  late IconData iconVal = Icons.abc;
  late Color iconColor = Colors.black;

  late Color borderColor = const Color(0xfffefefe);
  late double wid = 0.0;
  late double rad = 0.0;
  late double iconSize = 0.0;
  late Color backgroundColor = Colors.white;
  late double padding = 0.0;
  late String id;
  late String src = "";
  late UikAction action;

  UikIconProps();

  factory UikIconProps.fromJson(Map<String, dynamic> json) =>
      $UikIconPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
