import 'dart:convert';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_image_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:flutter/material.dart';

import 'WidgetProps.dart';

@JsonSerializable()
class UikImageProps extends WidgetProps {
  late String id;
  late String src;
  late double? height = 0.0;
  late double? width = 0.0;
  late double rad = 0.0;
  late double wid = 0.0;
  late BoxFit iFit;
  late dynamic opacity;
  late Color borderColor = Colors.white;
  late bool isCenter = false;
  double marginLeft;
  double marginRight;
  double marginTop;
  late UikAction action;

  UikImageProps({
    this.marginLeft = 0.0,
    this.marginRight = 0.0,
    this.marginTop = 0.0,
  });

  factory UikImageProps.fromJson(Map<String, dynamic> json) =>
      $UikImagePropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
