import 'dart:convert';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:flutter/material.dart';

import '../generated/json/uik_textChip_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikTextChipProps extends WidgetProps {
  late String id;
  late Widget text;
  late UikAction action;
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;
  late double topMargin = 0.0;
  late double bottomMargin = 0.0;
  Color bgColor = const Color(0xFFF5F5F5);
  double borderRadius = 4.0;

  UikTextChipProps();

  factory UikTextChipProps.fromJson(Map<String, dynamic> json) =>
      $UikTextChipPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
