import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;
import 'NavigatorService.dart';
import 'StandardPage.dart';
import 'props/ApiResponse.dart';
import 'props/UikAction.dart';
import 'utils/pubsub/localpubsub.dart';

class Test extends StatefulWidget {
  const Test({Key? key}) : super(key: key);

  @override
  State<Test> createState() => _TestState();
}

class _TestState extends State<Test> {
  @override
  Widget build(BuildContext context) {
    return TestPage().page;
  }
}

class TestPage extends StandardPage {
  @override
  dynamic getData() {
    return fetchAlbum;
  }

  @override
  Set<String?> getActions() {
    Set<String?> actionList = Set();
    actionList.add("OPEN_WEB");
    actionList.add("OPEN_ROUTE");
    actionList.add("ADD_TO_CART");
    actionList.add("OPEN_CATEGORY");
    return actionList;
  }

  @override
  getPageCallBackForAction() {
    return of;
  }

  void of(UikAction uikAction) {
    print(uikAction);
    var context = NavigationService.navigatorKey.currentContext;
    print(context);
    String type = uikAction.tap.type;
    switch (type) {
      case "OPEN_WEB":
        {
          print("OPEN_WEB");
        }
        break;
      case "OPEN_ROUTE":
        {
          print("inside the case of open route");
        }
        break;
      case "OPEN_CATEGORY":
        {
          print("Inside OPEN_CATEGORY");
        }
        break;
      default:
        {
          print("default switch case :(");
        }
        break;
    }
    PubSub pubsub = PubSub();
    print("mainScreen ${pubsub.stack.top()}");
  }

  @override
  getPageContext() {
    return TestPage;
  }
}

Future<ApiResponse> fetchAlbum(args) async {
  final queryParameter = {
    "id": "eb5f37b2-ca34-40a1-83ba-cb161eb55e6e",
  };

  //https://bc4c-1-38-54-6.ngrok.io
  final response = await http.post(
      Uri.parse('https://bc4c-1-38-54-6.ngrok.io/products/get'),
      headers: {
        "ngrok-skip-browser-warning": "value",
      },
      body: {
        "categoryId": args.toString(),
      });

  print(response.body);

  if (response.statusCode == 200) {
    return ApiResponse.fromJson(jsonDecode(response.body));
  } else {
    throw Exception('Failed to load album');
  }
}
